norm.hier.L.mcmc <- function(muj.mat){

####
####  Code Box 19.4 
####

####
####  Setup Variables 
####

n.mcmc=dim(muj.mat)[2]
J=dim(muj.mat)[1]

mu.save=rep(0,n.mcmc)
s2.save=rep(0,n.mcmc)
muj.save=matrix(0,J,n.mcmc)

####
####  Hyperparameters and Starting Values 
####

q=0.001
r=1000

mu.0=0
s2.0=10000

mu=mean(unlist(y.list))
muj=sapply(y.list,mean)
s2j=sapply(y.list,var)
rl=as.relistable(y.list)

####
####  Begin MCMC Loop 
####

for(k in 1:n.mcmc){
  if((k%%1000)==0) cat(k," ")

  ####
  ####  Sample s2 
  ####

  q.tmp=J/2+q
  r.tmp=1/(sum((muj-mu)^2)/2+1/r)
  s2=1/rgamma(1,q.tmp,,r.tmp)

  ####
  ####  Sample mu 
  ####

  tmp.var=1/(J/s2+1/s2.0)
  tmp.mn=tmp.var*(sum(muj)/s2+mu.0/s2.0)
  mu=rnorm(1,tmp.mn,sqrt(tmp.var))

  ####
  ####  Sample mu_j
  ####
 
  muj.star=muj.mat[,k]
  mh.1=dnorm(muj.star,mu,sqrt(s2),log=TRUE)+dnorm(muj,0,sqrt(10000),log=TRUE)
  mh.2=dnorm(muj,mu,sqrt(s2),log=TRUE)+dnorm(muj.star,0,sqrt(10000),log=TRUE)
  keep.idx=exp(mh.1-mh.2)>runif(J)
  muj[keep.idx]=muj.star[keep.idx]

  ####
  ####  Save Samples 
  ####

  mu.save[k]=mu
  s2.save[k]=s2
  muj.save[,k]=muj

};cat("\n")

####
####  Write Output 
####

list(n.mcmc=n.mcmc,mu.save=mu.save,s2.save=s2.save,muj.save=muj.save)

}

