reg.hmc <- function(y,X,beta.mn,beta.var,n.mcmc){

###
### Code Box 29.5
###

###
### Hyperpriors
###

n=dim(X)[1]
p=dim(X)[2]
T=100
dt=.01
r=1000
q=0.001
Sig.beta=beta.var*diag(p)
Sig.beta.inv=solve(Sig.beta)
beta.sd=sqrt(beta.var)

beta.save=matrix(0,p,n.mcmc)
s2.save=rep(0,n.mcmc)

###
### Starting Values
###

XpX=t(X)%*%X
beta=solve(XpX)%*%t(X)%*%y
v.star=rnorm(p)

beta.acc=0

###
### MCMC Loop
###

for(k in 1:n.mcmc){
  if(k%%100==0) cat(k," ")

  ###
  ### Sample s2
  ###

  tmp.r=(1/r+.5*t(y-X%*%beta)%*%(y-X%*%beta))^(-1)
  tmp.q=n/2+q

  s2=1/rgamma(1,tmp.q,,tmp.r) 
  sig=sqrt(s2)

  ###
  ### Sample beta
  ###

  beta.star=beta
  v=rnorm(p)
  v.star=v
  for(t in 1:T){
    v.star=v.star-(dt/2)*((XpX/s2+Sig.beta.inv)%*%beta.star-(t(X)%*%y/s2+Sig.beta.inv%*%beta.mn))
    beta.star=beta.star+dt*v.star
    v.star=v.star-(dt/2)*((XpX/s2+Sig.beta.inv)%*%beta.star-(t(X)%*%y/s2+Sig.beta.inv%*%beta.mn)) 
  }

  mh.1=sum(dnorm(y,X%*%beta.star,sig,log=TRUE))+sum(dnorm(beta.star,beta.mn,beta.sd,log=TRUE))+sum(dnorm(v.star,log=TRUE))
  mh.2=sum(dnorm(y,X%*%beta,sig,log=TRUE))+sum(dnorm(beta,beta.mn,beta.sd,log=TRUE))+sum(dnorm(v,log=TRUE))
  mh=exp(mh.1-mh.2)
  if(mh>runif(1)){
    beta=beta.star
    beta.acc=beta.acc+1
  }
 
  ###
  ### Save Samples
  ###
  
  beta.save[,k]=beta
  s2.save[k]=s2

}
cat("\n")

###
###  Write Output
###

list(beta.save=beta.save,s2.save=s2.save,y=y,X=X,n.mcmc=n.mcmc,n=n,r=r,q=q,p=p,T=T,dt=dt,beta.acc=beta.acc)

}

